///File : MenuScreen.hpp
//------------------------------------------------------------------------------
/*
    This file is part of MaxiShoot.

    MaxiShoot is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    MaxiShoot is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MaxiShoot.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#if not defined MENU_SCREEN_HPP_MAXI_SHOOT
#define MENU_SCREEN_HPP_MAXI_SHOOT
//------------------------------------------------------------------------------
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>

#include <string>
#include <iostream>
//------------------------------------------------------------------------------
#include "myConf.hpp"
#include "Screen.hpp"
#include "main.hpp"
//------------------------------------------------------------------------------
#define MAIN_MENU 0
#define QUIT_MENU 1
#define OPTION_MENU 2
#define PLAY_MENU 3
#define MODE_MENU 4
#define SOUND_MENU 5
#define VIDEO_MENU 6

#define SCREEN_WIDTH 1280.f
#define SCREEN_HEIGHT 1024.f

//------------------------------------------------------------------------------
struct StructModePresentation
{
    bool isOk;
    std::string modeDir;
    std::string auther;
    std::string modeName;
    sf::Image screenShot;
};

void LoadModePresetation(void* UserData);

//------------------------------------------------------------------------------
class MenuScreen : public Screen
{
public:
    MenuScreen(ConfigObj *configObj);
    ~MenuScreen();
    virtual int Run(sf::RenderWindow &App);

private:
    int m_menuChoice;
    int m_menuId;

    std::vector<sf::String> m_Menu;
    sf::String m_MenuTitle;

    void MenuUp();
    void MenuDown();
    bool MenuAction(int &returnValue);
    void CreateMenu();

    std::string m_tmpMode;

    sf::Thread *m_modePresentationThread;

    StructModePresentation m_modePresentation;
};
//------------------------------------------------------------------------------
class AboutScreen : public Screen
{
public:
    AboutScreen(ConfigObj *configObj);
    virtual int Run(sf::RenderWindow &App);
};
#endif // MENU_SCREEN_HPP_MAXI_SHOOT
